function dn_plot_init(plot_nr);

main_data = get(gcf,'UserData');

sim_active_tmp       = main_data.sim_active;
main_data.sim_active = 0;
set(gcf,'UserData',main_data);

if (plot_nr == 1)
    tag_axes                                  = 'demo_nlms_axes_top';
    set(gcf,'CurrentAxes',findobj('Tag',tag_axes));
    plot_method                               = main_data.axes_top.plot_method;
    main_data.axes_top.index                  = 0;
    main_data.axes_top.plot_method_changed    = 0;
else
    tag_axes                                  = 'demo_nlms_axes_bottom';
    set(gcf,'CurrentAxes',findobj('Tag',tag_axes)); 
    plot_method                               = main_data.axes_bottom.plot_method;
    main_data.axes_bottom.index               = 0;
    main_data.axes_bottom.plot_method_changed = 0;
end;

handle_1 = 0;
handle_2 = 0;

switch plot_method
    
    case 'bar_h_hat_h'
        
        cla;        
        handle_1(1) = patch([-0.45 -0.05 -0.05 -0.45],[0 0 main_data.system.h(1) main_data.system.h(1)],'b');
        set(handle_1(1),'EraseMode','xor');
        handle_2(1) = patch([0.05 0.45 0.45 0.05],[0 0 main_data.adap_filter.h(1) main_data.adap_filter.h(1)],'r');
        set(handle_2(1),'EraseMode','xor');
        for k = 1:length(main_data.system.h)-1
            handle_1(k+1) = patch([k-0.45 k-0.05 k-0.05 k-0.45],[0 0 main_data.system.h(k+1) main_data.system.h(k+1)],'b');
            set(handle_1(k+1),'EraseMode','xor');
        end;
        for k = 1:length(main_data.adap_filter.h)-1
            handle_2(k+1) = patch([k+0.05 k+0.45 k+0.45 k+0.05],[0 0 main_data.adap_filter.h(k+1) main_data.adap_filter.h(k+1)],'r');
            set(handle_2(k+1),'EraseMode','xor');
        end;                           
        axis([-1 max(length(main_data.adap_filter.h),length(main_data.system.h)) -1.2*max(max(main_data.system.h),max(main_data.adap_filter.h)) 1.2*max(max(main_data.system.h),max(main_data.adap_filter.h))]);
        grid on;  
        legend(' Unknown system',' Adaptive filter');
        xlabel('Coefficient index');

    case 'line_h_hat_h'
        
        cla;
        handle_temp = plot((0:length(main_data.system.h)-1),main_data.system.h,'b',(0:length(main_data.adap_filter.h)-1),main_data.adap_filter.h,'r','LineWidth',2,'EraseMode','xor');
        handle_1 = handle_temp(1);
        handle_2 = handle_temp(2);
        axis([-1 max(length(main_data.adap_filter.h),length(main_data.system.h)) -1.2*max(max(main_data.system.h),max(main_data.adap_filter.h)) 1.2*max(max(main_data.system.h),max(main_data.adap_filter.h))]);
        grid on;  
        legend(' Unknown system',' Adaptive filter');
        xlabel('Coefficient index');        
        
    case 'sys_dist'               
        
        cla;
        handle_1 = plot([-2 -1],[0 0],'b','LineWidth',2,'EraseMode','none');
        handle_2 = 0;
        axis([0 50*length(main_data.adap_filter.h) -main_data.system.snr_db-20 20]);
        grid on;
        legend('System distance');
        xlabel('Iterations');
        ylabel('dB');
        drawnow;
        
    case 'short_term_power'               
        
        cla;
        handle_temp = plot([-2 -1],[0 0],'b',[-2 -1],[0 0],'r','LineWidth',2,'EraseMode','none');
        handle_1 = handle_temp(1);
        handle_2 = handle_temp(2);
        axis([0 50*length(main_data.adap_filter.h) -main_data.system.snr_db-10 30]);
        grid on;
        legend('System output signal','Error signal');
        xlabel('Iterations');
        ylabel('dB');
        drawnow;        
end;

if (plot_nr == 1)
    main_data.axes_top.plot_handle_1 = handle_1;
    main_data.axes_top.plot_handle_2 = handle_2;
else
    main_data.axes_bottom.plot_handle_1 = handle_1;
    main_data.axes_bottom.plot_handle_2 = handle_2;    
end;

set(gca,'Tag',tag_axes);


main_data.sim_active = sim_active_tmp;
set(gcf,'UserData',main_data);