function dn_plot_update(plot_nr);

main_data = get(gcf,'UserData');

if (plot_nr == 1)
    tag_axes = 'demo_nlms_axes_top';
    set(gcf,'CurrentAxes',findobj('Tag',tag_axes));
    plot_method                      = main_data.axes_top.plot_method;
    plot_handle_1                    = main_data.axes_top.plot_handle_1;
    plot_handle_2                    = main_data.axes_top.plot_handle_2;
    update_flag                      = main_data.axes_top.update_flag_h; 
    main_data.axes_top.update_flag_h = 0;
    index                            = main_data.axes_top.index;
else
    tag_axes = 'demo_nlms_axes_bottom';
    set(gcf,'CurrentAxes',findobj('Tag',tag_axes)); 
    plot_method                         = main_data.axes_bottom.plot_method;
    plot_handle_1                       = main_data.axes_bottom.plot_handle_1;
    plot_handle_2                       = main_data.axes_bottom.plot_handle_2;    
    update_flag                         = main_data.axes_bottom.update_flag_h;         
    main_data.axes_bottom.update_flag_h = 0;
    index                               = main_data.axes_bottom.index;
end;

switch plot_method
    
    case 'bar_h_hat_h'
        
        for k = 1:length(main_data.adap_filter.h)
           set(plot_handle_2(k),'YData',[0 0 main_data.adap_filter.h(k) main_data.adap_filter.h(k)]);
        end;
        if (update_flag == 1)
           for k = 1:length(main_data.system.h)
              set(plot_handle_1(k),'YData',[0 0 main_data.system.h(k) main_data.system.h(k)]);
           end;
        end;
        
    case 'line_h_hat_h'
        
        set(plot_handle_2,'YData',main_data.adap_filter.h);
        if (update_flag == 1)
            set(plot_handle_1,'YData',main_data.system.h);
        end;        
        
    case 'sys_dist'               
        index = index + 1;
        sd = 10*log10(((main_data.system.h'-main_data.adap_filter.h')*(main_data.system.h-main_data.adap_filter.h)/(main_data.system.h'*main_data.system.h) )+eps);
        if (index > 50*length(main_data.adap_filter.h))
            set(plot_handle_1,'XData',[-2 -1],'YData',[sd sd],'EraseMode','normal');
            index = 0;
            drawnow;
            set(plot_handle_1,'XData',[-2 -1],'YData',[sd sd],'EraseMode','none');          
        else
            ydata_old = get(plot_handle_1,'YData');            
            xdata_old = get(plot_handle_1,'XData');
            set(plot_handle_1,'XData',[xdata_old index],'YData',[ydata_old sd]);
        end;     
        
    case 'short_term_power'               
        index = index + 1;
        p_y = 10*log10(main_data.system.p_y+eps);
        p_e = 10*log10(main_data.system.p_e+eps);
        if (index > 50*length(main_data.adap_filter.h))
            set(plot_handle_1,'XData',[-2 -1],'YData',[p_y p_y],'EraseMode','normal');
            set(plot_handle_2,'XData',[-2 -1],'YData',[p_e p_e],'EraseMode','normal');
            index = 0;
            drawnow;
            set(plot_handle_1,'XData',[-2 -1],'YData',[p_y p_y],'EraseMode','none');          
            set(plot_handle_2,'XData',[-2 -1],'YData',[p_e p_e],'EraseMode','none');
        else
            p_y_ydata_old = get(plot_handle_1,'YData');            
            p_y_xdata_old = get(plot_handle_1,'XData');
            set(plot_handle_1,'XData',[p_y_xdata_old index],'YData',[p_y_ydata_old p_y]);
            if (plot_handle_2 == 0)
                p_e_ydata_old = 0;
                p_e_xdata_old = p_y_xdata_old;               
            else
                p_e_ydata_old = get(plot_handle_2,'YData');            
                p_e_xdata_old = get(plot_handle_2,'XData');
                set(plot_handle_2,'XData',[p_e_xdata_old index],'YData',[p_e_ydata_old p_e]);                                 
            end;
                       
        end;          
                         
end;

if (plot_nr == 1)
    main_data.axes_top.index = index;
else
    main_data.axes_bottom.index = index;     
end;

set(gca,'Tag',tag_axes);
set(gcf,'UserData',main_data);

drawnow;

