function dn_update_nlms;

main_data = get(gcf,'UserData');

%**************************************************************************
% Update excitation vectors
%**************************************************************************

excitation = randn(1,1);
main_data.system.x      = [excitation; main_data.system.x(1:end-1)];
main_data.adap_filter.x = [excitation; main_data.adap_filter.x(1:end-1)];

%**************************************************************************
% Compute system output
%**************************************************************************

noise              = randn(1,1) * 10^(-main_data.system.snr_db/20);
main_data.system.n = noise;
main_data.system.y = main_data.system.x' * main_data.system.h + noise;

%**************************************************************************
% Compute error signal
%**************************************************************************

main_data.adap_filter.e = main_data.system.y - main_data.adap_filter.x' * main_data.adap_filter.h;

%**************************************************************************
% Short-term powers
%**************************************************************************

main_data.system.p_x = main_data.system.sm_const_pow * main_data.system.p_x  + ...
                       (1 - main_data.system.sm_const_pow) * excitation^2;
main_data.system.p_y = main_data.system.sm_const_pow * main_data.system.p_y  + ...
                       (1 - main_data.system.sm_const_pow) * main_data.system.y^2;       
main_data.system.p_e = main_data.system.sm_const_pow * main_data.system.p_e  + ...
                       (1 - main_data.system.sm_const_pow) * main_data.adap_filter.e^2;                      

%**************************************************************************
% Update filter
%**************************************************************************

main_data.adap_filter.h = main_data.adap_filter.h ...
    + main_data.adap_filter.stepsize * main_data.adap_filter.e ...
      * main_data.adap_filter.x / (main_data.adap_filter.x'*main_data.adap_filter.x + eps);

set(gcf,'UserData',main_data);